<html>
<head>
<title>OgreD3D11VertexDeclaration.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_43d9b0265a5a2fd53bf3892a292ce5e9.html">RenderSystems</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a2df88393729a3f182c00116937c948.html">Direct3D11</a>      </li>
      <li class="navelem"><a class="el" href="dir_80c990f15d364d52e4690b415f060ae9.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreD3D11VertexDeclaration.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreD3D11VertexDeclaration_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">(Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __D3D11VERTEXDECLARATION_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __D3D11VERTEXDECLARATION_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgreD3D11Prerequisites_8h.html">OgreD3D11Prerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreHighLevelGpuProgramManager_8h.html">OgreHighLevelGpuProgramManager.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Ogre { 
<a name="l00036"></a>00036 
<a name="l00038"></a><a class="code" href="classOgre_1_1D3D11VertexDeclaration.html">00038</a>     <span class="keyword">class </span><a class="code" href="classOgre_1_1D3D11VertexDeclaration.html" title="Specialisation of VertexDeclaration for D3D11.">D3D11VertexDeclaration</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>
<a name="l00039"></a>00039     {
<a name="l00040"></a>00040     <span class="keyword">protected</span>:
<a name="l00041"></a><a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#a2fa641ef16822696a52f377fb7714675">00041</a>         <a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp; <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#a2fa641ef16822696a52f377fb7714675">mlpD3DDevice</a>;
<a name="l00042"></a>00042 
<a name="l00043"></a><a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#a9a2ccb70b59d0980306304f375788463">00043</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#a9a2ccb70b59d0980306304f375788463">mNeedsRebuild</a>;
<a name="l00044"></a>00044 
<a name="l00045"></a><a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#a51817b5c37dd09f0ad88e33e8b969297">00045</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;D3D11HLSLProgram*, ID3D11InputLayout*&gt;::type</a> <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#a51817b5c37dd09f0ad88e33e8b969297">ShaderToILayoutMap</a>;
<a name="l00046"></a><a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#aa1e624ad07ab3e5724455852c00298fc">00046</a>         <span class="keyword">typedef</span> ShaderToILayoutMap::iterator <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#aa1e624ad07ab3e5724455852c00298fc">ShaderToILayoutMapIterator</a>;
<a name="l00047"></a><a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#ab0a1ad37608c81cbcabb9541f3caa6be">00047</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;D3D11HLSLProgram*, D3D11_INPUT_ELEMENT_DESC*&gt;::type</a> <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#ab0a1ad37608c81cbcabb9541f3caa6be">ShaderToInputDesc</a>;
<a name="l00048"></a><a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#ad60220fade90c62a80750156e8266259">00048</a>         <span class="keyword">typedef</span> ShaderToInputDesc::iterator <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#ad60220fade90c62a80750156e8266259">ShaderToInputDescIterator</a>;
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#ac544a97600aab8cfede541c2c133e553">00050</a>         <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#ab0a1ad37608c81cbcabb9541f3caa6be">ShaderToInputDesc</a>  <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#ac544a97600aab8cfede541c2c133e553">mD3delems</a>;
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#ad6ff6891cf62ff5d054a94be75e36868">00052</a>         <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#a51817b5c37dd09f0ad88e33e8b969297">ShaderToILayoutMap</a> <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#ad6ff6891cf62ff5d054a94be75e36868">mShaderToILayoutMap</a>;
<a name="l00053"></a>00053 
<a name="l00056"></a>00056         ID3D11InputLayout   *  <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#a2a9dabfc910bb3fd63d551be9c0f18ab" title="Gets the D3D11-specific vertex declaration.">getILayoutByShader</a>(<a class="code" href="classOgre_1_1D3D11HLSLProgram.html" title="Specialization of HighLevelGpuProgram to provide support for D3D11 High-Level Shader Language (HLSL)...">D3D11HLSLProgram</a>* boundVertexProgram, <a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* binding);
<a name="l00057"></a>00057     <span class="keyword">public</span>:
<a name="l00058"></a>00058         <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#af18a3fbb49699744c47d35823c2715f8">D3D11VertexDeclaration</a>(<a class="code" href="classOgre_1_1D3D11Device.html">D3D11Device</a> &amp;  device);
<a name="l00059"></a>00059         <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#a0ac311130d8afc93a5804c52ce9fc1c5">~D3D11VertexDeclaration</a>();
<a name="l00060"></a>00060 
<a name="l00062"></a>00062         <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a>&amp; <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#a0b22ca64048c29d9aedba59248037340" title="See VertexDeclaration.">addElement</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> source, <span class="keywordtype">size_t</span> offset, <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> theType,
<a name="l00063"></a>00063             <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0);
<a name="l00064"></a>00064 
<a name="l00066"></a>00066         <span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexElement.html" title="This class declares the usage of a single vertex buffer as a component of a complete VertexDeclaratio...">VertexElement</a>&amp; <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#ae9ae32b941df609c348461526b1d4508" title="See VertexDeclaration.">insertElement</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> atPosition,
<a name="l00067"></a>00067             <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> source, <span class="keywordtype">size_t</span> offset, <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> theType,
<a name="l00068"></a>00068             <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0);
<a name="l00069"></a>00069 
<a name="l00071"></a>00071         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#a5ded543189a60d17996a095bd2c1dc9f" title="See VertexDeclaration.">removeElement</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> elem_index);
<a name="l00072"></a>00072 
<a name="l00074"></a>00074         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#a5ded543189a60d17996a095bd2c1dc9f" title="See VertexDeclaration.">removeElement</a>(<a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0);
<a name="l00075"></a>00075 
<a name="l00077"></a>00077         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#ac9ce837e81bbf38f2a48ac958d222bce" title="See VertexDeclaration.">removeAllElements</a>(<span class="keywordtype">void</span>);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00081"></a>00081         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#a9c5169a898e25dfd498d446eab36ab0e" title="See VertexDeclaration.">modifyElement</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> elem_index, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> source, <span class="keywordtype">size_t</span> offset, <a class="code" href="group__RenderSystem.html#ga027109503a988ba85f4c63b55082907f" title="Vertex element type, used to identify the base types of the vertex contents.">VertexElementType</a> theType,
<a name="l00082"></a>00082             <a class="code" href="group__RenderSystem.html#ga0a62b3f2ede8992ff365bb013a8bc00d" title="Vertex element semantics, used to identify the meaning of vertex buffer contents.">VertexElementSemantic</a> semantic, <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> index = 0);
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085         D3D11_INPUT_ELEMENT_DESC * <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#aeb7e79ecee3cee29b0299b9ff00b2856">getD3DVertexDeclaration</a>(<a class="code" href="classOgre_1_1D3D11HLSLProgram.html" title="Specialization of HighLevelGpuProgram to provide support for D3D11 High-Level Shader Language (HLSL)...">D3D11HLSLProgram</a>* boundVertexProgram, <a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* binding);
<a name="l00086"></a>00086         <span class="keywordtype">void</span> <a class="code" href="classOgre_1_1D3D11VertexDeclaration.html#ad87e82fb10c0d27b3acf91f0203a7cfb">bindToShader</a>(<a class="code" href="classOgre_1_1D3D11HLSLProgram.html" title="Specialization of HighLevelGpuProgram to provide support for D3D11 High-Level Shader Language (HLSL)...">D3D11HLSLProgram</a>* boundVertexProgram, <a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* binding);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088     };
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 <span class="preprocessor">#endif</span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:49
</p>
</body>
</html>
